# kgXref.sql was originally generated by the autoSql program, which also 
# generated kgXref.c and kgXref.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#Link together a Known Gene ID and a gene alias
CREATE TABLE kgXref (
    kgID varchar(40) not null,	# Known Gene ID
    mRNA varchar(40),		# mRNA ID
    spID varchar(40),		# SWISS-PROT protein Accession number
    spDisplayID varchar(40),	# SWISS-PROT display ID
    geneSymbol varchar(40),	# Gene Symbol
    refseq varchar(40),		# RefSeq ID
    protAcc varchar(40),	# NCBI protein Accession number
    description varchar(255),	# Description
              #Indices
    PRIMARY KEY(kgID),
    KEY(mRNA),
    KEY(spID),
    KEY(spDisplayID),
    KEY(geneSymbol),
    KEY(refseq),
    KEY(protAcc)
);
