/* pseudoGeneLink.c was originally generated by the autoSql program, which also 
 * generated pseudoGeneLink.h and pseudoGeneLink.sql.  This module links the database and
 * the RAM representation of objects. */

#include "common.h"
#include "linefile.h"
#include "dystring.h"
#include "jksql.h"
#include "pseudoGeneLink.h"

static char const rcsid[] = "$Id: pseudoGeneLink.c,v 1.7 2003/12/04 07:59:38 baertsch Exp $";

struct pseudoGeneLink *pseudoGeneLinkLoad(char **row)
/* Load a pseudoGeneLink from row fetched with select * from pseudoGeneLink
 * from database.  Dispose of this with pseudoGeneLinkFree(). */
{
struct pseudoGeneLink *ret;
int sizeOne,i;
char *s;

AllocVar(ret);
ret->blockCount = sqlSigned(row[10]);
ret->bin = sqlSigned(row[0]);
ret->chrom = cloneString(row[1]);
ret->chromStart = sqlUnsigned(row[2]);
ret->chromEnd = sqlUnsigned(row[3]);
ret->name = cloneString(row[4]);
ret->score = sqlUnsigned(row[5]);
ret->strand = cloneString(row[6]);
ret->thickStart = sqlUnsigned(row[7]);
ret->thickEnd = sqlUnsigned(row[8]);
ret->reserved = sqlUnsigned(row[9]);
sqlSignedDynamicArray(row[11], &ret->blockSizes, &sizeOne);
assert(sizeOne == ret->blockCount);
sqlSignedDynamicArray(row[12], &ret->chromStarts, &sizeOne);
assert(sizeOne == ret->blockCount);
ret->assembly = cloneString(row[13]);
ret->geneTable = cloneString(row[14]);
ret->gene = cloneString(row[15]);
ret->gChrom = cloneString(row[16]);
ret->gStart = sqlUnsigned(row[17]);
ret->gEnd = sqlUnsigned(row[18]);
ret->gStrand = cloneString(row[19]);
ret->exonCount = sqlUnsigned(row[20]);
ret->geneOverlap = sqlUnsigned(row[21]);
ret->polyA = sqlUnsigned(row[22]);
ret->polyAstart = sqlUnsigned(row[23]);
ret->exonCover = sqlUnsigned(row[24]);
ret->intronCount = sqlUnsigned(row[25]);
ret->bestAliCount = sqlUnsigned(row[26]);
ret->matches = sqlUnsigned(row[27]);
ret->qSize = sqlUnsigned(row[28]);
ret->qEnd = sqlUnsigned(row[29]);
ret->tReps = sqlUnsigned(row[30]);
ret->qReps = sqlUnsigned(row[31]);
ret->overlapDiag = sqlUnsigned(row[32]);
ret->coverage = sqlUnsigned(row[33]);
ret->chainId = sqlUnsigned(row[34]);
return ret;
}

struct pseudoGeneLink *pseudoGeneLinkLoadAll(char *fileName) 
/* Load all pseudoGeneLink from a whitespace-separated file.
 * Dispose of this with pseudoGeneLinkFreeList(). */
{
struct pseudoGeneLink *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[35];

while (lineFileRow(lf, row))
    {
    el = pseudoGeneLinkLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct pseudoGeneLink *pseudoGeneLinkLoadAllByChar(char *fileName, char chopper) 
/* Load all pseudoGeneLink from a chopper separated file.
 * Dispose of this with pseudoGeneLinkFreeList(). */
{
struct pseudoGeneLink *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[35];

while (lineFileNextCharRow(lf, chopper, row, ArraySize(row)))
    {
    el = pseudoGeneLinkLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct pseudoGeneLink *pseudoGeneLinkCommaIn(char **pS, struct pseudoGeneLink *ret)
/* Create a pseudoGeneLink out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new pseudoGeneLink */
{
char *s = *pS;
int i;

if (ret == NULL)
    AllocVar(ret);
ret->bin = sqlSignedComma(&s);
ret->chrom = sqlStringComma(&s);
ret->chromStart = sqlUnsignedComma(&s);
ret->chromEnd = sqlUnsignedComma(&s);
ret->name = sqlStringComma(&s);
ret->score = sqlUnsignedComma(&s);
ret->strand = sqlStringComma(&s);
ret->thickStart = sqlUnsignedComma(&s);
ret->thickEnd = sqlUnsignedComma(&s);
ret->reserved = sqlUnsignedComma(&s);
ret->blockCount = sqlSignedComma(&s);
s = sqlEatChar(s, '{');
AllocArray(ret->blockSizes, ret->blockCount);
for (i=0; i<ret->blockCount; ++i)
    {
    ret->blockSizes[i] = sqlSignedComma(&s);
    }
s = sqlEatChar(s, '}');
s = sqlEatChar(s, ',');
s = sqlEatChar(s, '{');
AllocArray(ret->chromStarts, ret->blockCount);
for (i=0; i<ret->blockCount; ++i)
    {
    ret->chromStarts[i] = sqlSignedComma(&s);
    }
s = sqlEatChar(s, '}');
s = sqlEatChar(s, ',');
ret->assembly = sqlStringComma(&s);
ret->geneTable = sqlStringComma(&s);
ret->gene = sqlStringComma(&s);
ret->gChrom = sqlStringComma(&s);
ret->gStart = sqlUnsignedComma(&s);
ret->gEnd = sqlUnsignedComma(&s);
ret->gStrand = sqlStringComma(&s);
ret->exonCount = sqlUnsignedComma(&s);
ret->geneOverlap = sqlUnsignedComma(&s);
ret->polyA = sqlUnsignedComma(&s);
ret->polyAstart = sqlUnsignedComma(&s);
ret->exonCover = sqlUnsignedComma(&s);
ret->intronCount = sqlUnsignedComma(&s);
ret->bestAliCount = sqlUnsignedComma(&s);
ret->matches = sqlUnsignedComma(&s);
ret->qSize = sqlUnsignedComma(&s);
ret->qEnd = sqlUnsignedComma(&s);
ret->tReps = sqlUnsignedComma(&s);
ret->qReps = sqlUnsignedComma(&s);
ret->overlapDiag = sqlUnsignedComma(&s);
ret->coverage = sqlUnsignedComma(&s);
ret->chainId = sqlUnsignedComma(&s);
*pS = s;
return ret;
}

void pseudoGeneLinkFree(struct pseudoGeneLink **pEl)
/* Free a single dynamically allocated pseudoGeneLink such as created
 * with pseudoGeneLinkLoad(). */
{
struct pseudoGeneLink *el;

if ((el = *pEl) == NULL) return;
freeMem(el->chrom);
freeMem(el->name);
freeMem(el->strand);
freeMem(el->blockSizes);
freeMem(el->chromStarts);
freeMem(el->assembly);
freeMem(el->geneTable);
freeMem(el->gene);
freeMem(el->gChrom);
freeMem(el->gStrand);
freez(pEl);
}

void pseudoGeneLinkFreeList(struct pseudoGeneLink **pList)
/* Free a list of dynamically allocated pseudoGeneLink's */
{
struct pseudoGeneLink *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    pseudoGeneLinkFree(&el);
    }
*pList = NULL;
}

void pseudoGeneLinkOutput(struct pseudoGeneLink *el, FILE *f, char sep, char lastSep) 
/* Print out pseudoGeneLink.  Separate fields with sep. Follow last field with lastSep. */
{
int i;
fprintf(f, "%d", el->bin);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->chrom);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->chromStart);
fputc(sep,f);
fprintf(f, "%u", el->chromEnd);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->name);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->score);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->strand);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->thickStart);
fputc(sep,f);
fprintf(f, "%u", el->thickEnd);
fputc(sep,f);
fprintf(f, "%u", el->reserved);
fputc(sep,f);
fprintf(f, "%d", el->blockCount);
fputc(sep,f);
if (sep == ',') fputc('{',f);
for (i=0; i<el->blockCount; ++i)
    {
    fprintf(f, "%d", el->blockSizes[i]);
    fputc(',', f);
    }
if (sep == ',') fputc('}',f);
fputc(sep,f);
if (sep == ',') fputc('{',f);
for (i=0; i<el->blockCount; ++i)
    {
    fprintf(f, "%d", el->chromStarts[i]);
    fputc(',', f);
    }
if (sep == ',') fputc('}',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->assembly);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->geneTable);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->gene);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->gChrom);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->gStart);
fputc(sep,f);
fprintf(f, "%u", el->gEnd);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->gStrand);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->exonCount);
fputc(sep,f);
fprintf(f, "%u", el->geneOverlap);
fputc(sep,f);
fprintf(f, "%u", el->polyA);
fputc(sep,f);
fprintf(f, "%u", el->polyAstart);
fputc(sep,f);
fprintf(f, "%u", el->exonCover);
fputc(sep,f);
fprintf(f, "%u", el->intronCount);
fputc(sep,f);
fprintf(f, "%u", el->bestAliCount);
fputc(sep,f);
fprintf(f, "%u", el->matches);
fputc(sep,f);
fprintf(f, "%u", el->qSize);
fputc(sep,f);
fprintf(f, "%u", el->qEnd);
fputc(sep,f);
fprintf(f, "%u", el->tReps);
fputc(sep,f);
fprintf(f, "%u", el->qReps);
fputc(sep,f);
fprintf(f, "%u", el->overlapDiag);
fputc(sep,f);
fprintf(f, "%u", el->coverage);
fputc(sep,f);
fprintf(f, "%u", el->chainId);
fputc(lastSep,f);
}

/* -------------------------------- End autoSql Generated Code -------------------------------- */

